module.exports = exports = Velocity;
var EE = require('events').EventEmitter;
var stats = {};
stats.differences = function(list) {
    var diffs = [];
    for (var i = 0; i < list.length - 1; i++ ) {
        var diff = list[i+1] - list[i];
        diffs.push(diff); 
    }
    return diffs;
};
stats.avg = function(list) {
    if ((list !== undefined) && (list.length !== 0)) {
        var sum = 0;
        list.forEach(function(val) {
            sum += val;
        });
        return Math.floor(sum / list.length);
    }
    return undefined;
};
function Velocity(params) {
    var watched = undefined;
    var self = {};
    var emitter = new EE;
    var props = {};
    var evNames = {};
    var timey = function() {
        var args = [].slice.call(arguments,0);
        var last = args.pop();
        if (evNames[last] === undefined) {
            evNames[last] = [];
        }
        var time = new Date();
        var ms = time.getTime();
        var list = evNames[last];
        list.push(ms);
    };
    self.watch = function(obj) {
        watched = obj; 
        self.value = obj;
        return self;
    };
    self.on = function(evName,fn) {
        if (fn === undefined) {
            fn = function(){};
        }
        emitter.on(evName,fn);
        emitter.on(evName,timey);
        var f = watched[evName].bind(watched);
        self[evName] = function() {
            var args = [].slice.call(arguments,0);
            var emitterargs = args.slice(0);
            emitterargs.unshift(evName);
            emitterargs.push(evName)
            emitter.emit.apply(emitter,emitterargs);
            f.apply(f,args);
            self.value = watched;
        };
        return self;
    };
    self.follow = function(evName) {
        emitter.on(evName,timey);
        var f = watched[evName].bind(watched);
        self[evName] = function() {
            var args = [].slice.call(arguments,0);
            var emitterargs = args.slice(0);
            emitterargs.unshift(evName);
            emitterargs.push(evName)
            emitter.emit.apply(emitter,emitterargs);
            f.apply(f,args);
            self.value = watched;
        };
        return self;
    };
    // returns whole number method actions per second
    self.getVelocity = function(name) {
        var diffs = stats.differences(evNames[name]);
        var avg = stats.avg(diffs);
        var velo = Math.floor(1000/avg);
        return velo;
    };
    return self; 
};
