var Velocity = require('../');


// test attempts to watch and then retrieve same object watched
exports.testWatchedUnchanged = function(test) {
    var speed = Velocity();
    var x = ['cat','dog'];
    test.expect(1);
    x = speed.watch(x);
    test.deepEqual(['cat','dog'],x.value);
    test.done();
};

// test attempts to check .on without a function
exports.testOnMethodNoFunction = function(test) {
    var speed = Velocity();
    var x = ['cat','dog'];
    test.expect(1);
    x = speed.watch(x);
    x.on('push');
    x.push('elephant'); 
    test.deepEqual(['cat','dog','elephant'],x.value);
    test.done();
};

// test attempts to check .on with a function
exports.testOnMethodWithFunction = function(test) {
    var speed = Velocity();
    var x = ['cat','dog'];
    var y = "bar";
    test.expect(2);
    x = speed.watch(x);
    x.on('push',function(el) { y = el.concat(y);});
    x.push('foo'); 
    // proof that it still works normally
    test.deepEqual(['cat','dog','foo'],x.value);
    // proof that the function was called on push
    test.equal("foobar",y);
    test.done();
};
